StubbleCultivatorEvent = {};
StubbleCultivatorEvent_mt = Class(StubbleCultivatorEvent, Event);

InitEventClass(StubbleCultivatorEvent, "StubbleCultivatorEvent");

function StubbleCultivatorEvent:emptyNew()
  local self = Event:new(StubbleCultivatorEvent_mt);
  self.className="StubbleCultivatorEvent";
  return self;
end;

function StubbleCultivatorEvent:new(object, isActive)
  local self = StubbleCultivatorEvent:emptyNew()
  self.object = object;
  self.isActive = isActive;
  return self;
end;

function StubbleCultivatorEvent:readStream(streamId, connection)
  local id = streamReadInt32(streamId);
  self.isActive = streamReadBool(streamId);
  self.object = networkGetObject(id);
  self:run(connection);
end;

function StubbleCultivatorEvent:writeStream(streamId, connection)
  streamWriteInt32(streamId, networkGetObjectId(self.object));
  streamWriteBool(streamId, self.isActive);
end;

function StubbleCultivatorEvent:run(connection)
  self.object:setStubbleCultivatorActive(self.isActive, true);
  if not connection:getIsServer() then
    g_server:broadcastEvent(StubbleCultivatorEvent:new(self.object, self.isActive), nil, connection, self.object);
  end;	
end;

function StubbleCultivatorEvent.sendEvent(StubbleCultivator, isActive)
  if g_server ~= nil then
    g_server:broadcastEvent(StubbleCultivatorEvent:new(StubbleCultivator, isActive), nil, nil, StubbleCultivator);
  else
    g_client:getServerConnection():sendEvent(StubbleCultivatorEvent:new(StubbleCultivator, isActive));
  end;
end;

