SpecializationUtil.registerSpecialization('StubbleCultivator', 'StubbleCultivator', g_currentModDirectory .. 'StubbleCultivator.lua');
local StubbleCultivatorSpec = SpecializationUtil.getSpecialization('StubbleCultivator');

StubbleCultivator_Register = {};
local modItem = ModsUtil.findModItemByModName(g_currentModName);
StubbleCultivator_Register.version = (modItem and modItem.version) and modItem.version or "1.2";

--
StubbleCultivator_Register.initialized = false

function StubbleCultivator_Register:loadMap(name)
	if self.specAdded then return; end;

	print('*** StubbleCultivator v'..StubbleCultivator_Register.version..' specialization loading ***');

	local addedTo = {};

	for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
		if v ~= nil then
			-- has rz15kasza spec -> continue
			local allowInsertion = SpecializationUtil.hasSpecialization(rz15kasza, v.specializations);

			--local customEnvironment;
			if allowInsertion then
				 print(('\tvehicleType %q has rz15kasza spec'):format(v.name));
				if v.name:find('.') then
					customEnvironment = Utils.splitString('.', v.name)[1];
          --print(('\t\tcustomEnvironment=%q'):format(customEnvironment));
				end;

				if customEnvironment then
					-- has StubbleCultivator spec -> abort
					if rawget(SpecializationUtil.specializations, customEnvironment .. '.StubbleCultivator') ~= nil or rawget(SpecializationUtil.specializations, customEnvironment .. '.StubbleCultivator') ~= nil then
						 print(('\t\talready has spec "StubbleCultivator" -> allowInsertion = true'));
						allowInsertion = true;
					end;
				end;
			end;

			if allowInsertion then
				print(('\tStubbleCultivator spec added to %q'):format(v.name));
				table.insert(v.specializations, StubbleCultivatorSpec);
				addedTo[#addedTo + 1] = v.name;
			end;
		end;
	end;


	self.specAdded = true;
end;

function StubbleCultivator_Register:update(dt)
  if not StubbleCultivator_Register.initialized then
    StubbleCultivator_Register.initialized = true -- Only initialize ONCE.
  end;
end;
  
-- Texts
StubbleCultivator.l10nTexts = {};
StubbleCultivator.l10nTexts["StubbleCultivator_Activate"] = g_i18n:getText("StubbleCultivator_Activate");
StubbleCultivator.l10nTexts["StubbleCultivator_Deactivate"] = g_i18n:getText("StubbleCultivator_Deactivate");

function StubbleCultivator_Register:deleteMap() end;
function StubbleCultivator_Register:keyEvent(unicode, sym, modifier, isDown) end;
function StubbleCultivator_Register:mouseEvent(posX, posY, isDown, isUp, button) end;
function StubbleCultivator_Register:draw() end;

addModEventListener(StubbleCultivator_Register);
